/** 
 * Course: SE2811
 * Term: Winter 201_-201_
 * Assignment: Lab 4
 * Author: 
 * Date: 
 */
package eventlogger;

import javax.swing.JButton;
import javax.swing.JFrame;

import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;


/**
 * Test Driver UI for the EventLogger class
 */
public class ClientUI extends JFrame implements ActionListener {
	private String title;

	/**
	 * create a dirt-simple window containing a JButton
	 * @param title the window title
	 */
	public ClientUI( String title ) {

		this.title = title;
		// create the containing window and set its size etc
		setTitle(title);
		setSize(300, 200);
		setLocation(400, 400);
		setResizable(false);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Retrieves the window's contentPane and sets the background color to white
		Container contentPane = getContentPane();
//		contentPane.setLayout(null);
		contentPane.setBackground(Color.WHITE);

		//Creation of "DoSomething" button
		JButton doButton;
		doButton = new JButton ("Do Something"); 
		doButton.setActionCommand("doit");
		doButton.setBounds(10, 130, 170, 30);
		doButton.addActionListener(this);	// subscribe to events
		contentPane.add(doButton);

		contentPane.validate();
		contentPane.repaint();

	}

	@Override
	/**
	 * override of ActionListener interface implemented by this class;
	 * listens for the JButton press and logs a dumb message using the EventLogWriter singleton.
	 */
	public void actionPerformed(ActionEvent event) {
		// Get a reference to the EventLogWriter singleton

		// Write the dumb message
		System.out.println(title + " an event occurred at " + new Date() );

		System.out.println(title + " starting thread 1");
//TODO: create a worker thread that runs 		logSomeEvents(title +":thread1", "errors.txt");


		System.out.println(title + " starting thread 2");
//TODO: create another worker thread that runs 		logSomeEvents(title + ":thread2", "warnings.txt");

	}

	// This method runs in a separate thread(s), logging messages to the specified file 
	// @param threadDescription - description of the thread running this method
	// @param logFilename - name of the file to log messages to 
	/*package*/ void logSomeEvents(String threadDescription, String logFilename ) {

		// get the Singleton object
		EventLogger eventLogger = EventLogger.getInstance(logFilename);

		for( int i=0; i<3; i++ ) { // log 3 events, pausing between each output
			eventLogger.logEvent(threadDescription + " logging event " + i);
			try {
				Thread.sleep(250);
			} catch( InterruptedException e ) {} // do nothing on interruption; just continue
		}
	}
}
